package vm

import (
	"context"
	"github.com/jinzhu/copier"
	"github.com/pkg/errors"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/helper/xerr"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/repository/result"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/utils"
	"gitlink.org.cn/JointCloud/pcm-openstack/openstack"
	"k8s.io/apimachinery/pkg/util/json"

	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/svc"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type UnpauseServerLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewUnpauseServerLogic(ctx context.Context, svcCtx *svc.ServiceContext) *UnpauseServerLogic {
	return &UnpauseServerLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *UnpauseServerLogic) UnpauseServer(req *types.UnpauseServerReq) (resp *types.UnpauseServerResp, err error) {
	// todo: add your logic here and delete this line
	UnpauseServerReq := &openstack.UnpauseServerReq{}
	err = copier.CopyWithOption(UnpauseServerReq, req, copier.Option{Converters: utils.Converters})
	UnpauseServerResp, err := l.svcCtx.OpenstackRpc.UnpauseServer(l.ctx, UnpauseServerReq)
	if err != nil {
		return nil, errors.Wrapf(xerr.NewErrMsg("c端创建失败"), "c端创建失败 : %v ,req:%+v", err, req)
	}
	marshal, err := json.Marshal(&UnpauseServerResp)
	if err != nil {
		return nil, result.NewDefaultError(err.Error())
	}
	json.Unmarshal(marshal, &resp)
	err = copier.CopyWithOption(&resp, &UnpauseServerResp, copier.Option{Converters: utils.Converters})
	return resp, err
}
